/*=====================================================================================================================

   " ".

      .

=======================================================================================================================

  :

  21.07.2015 [+] CheckVersionMax, CheckVersionProg, CheckVersionChange.
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scCheckVersion.sql,v 1.1 2015/07/22 11:12:39 tsk Exp $
======================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure 'CheckVersionMax'
EXECUTE CheckDropProcedure 'CheckVersionProg'
EXECUTE CheckDropProcedure 'CheckVersionChange'
--
GO
--=====================================================================================================================
CREATE PROCEDURE CheckVersionMax
AS
  SELECT MAX([Version]) AS MaxVersion
    FROM CWProgramm
    WHERE (NOT ([Version] = 'update'))
--
GO
--=====================================================================================================================
CREATE PROCEDURE CheckVersionProg @VR VARCHAR(50)
AS
  SELECT Programm FROM CWProgramm WHERE ([Version] = @VR)
--
GO
--=====================================================================================================================
CREATE PROCEDURE CheckVersionChange @VR VARCHAR(50)
AS
  SELECT Change FROM CWProgramm WHERE ([Version] = @VR)
--
GO
--=====================================================================================================================
-- :
-- 8.32.04200688
--
--EXECUTE CheckVersionMax
--EXECUTE CheckVersionProg 'update'
--EXECUTE CheckVersionProg '8.32.04200688'
EXECUTE CheckVersionChange '8.32.04200688'

