{=======================================================================================================================

   "".

    , , .

========================================================================================================================

  :

  08.03.2015 [*]  .
  27.02.2015 [+] :   .
  26.02.2015 [+] :     .
             [+] .
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgFirmEdit.pas,v 1.1 2015/03/08 05:02:36 tsk Exp $
=======================================================================================================================}
unit dgFirmEdit;

interface

uses  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, Vcl.Controls,
      Vcl.Forms, Vcl.Dialogs, Data.DB, Data.Win.ADODB, Vcl.StdCtrls, Vcl.Buttons, Vcl.DBCtrls, Vcl.Mask, DBCtrlsEh,
      DBGridEh, DBLookupEh,
      // Base, Comming & ComputerWare:
      dgBaseEdit, CommingADO, CommingString, dmLookUpData;

type
  TFirmEditDG = class(TBASEEditDG)
    taDataIdClient: TAutoIncField;
    taDataClntNameFull: TStringField;
    taDataTrademark: TSmallintField;
    taDataClntNameShort: TStringField;
    taDataDisplayName: TStringField;
    taDataCountDoc: TIntegerField;
    taDataCountModel: TIntegerField;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    cbTrade: TDBLookupComboboxEh;
    edName: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    sbModel: TSpeedButton;
    btQuotes: TSpeedButton;
    procedure taDataBeforePost(DataSet: TDataSet);
    procedure btQuotesClick(Sender: TObject);
    procedure sbModelClick(Sender: TObject);
  private { Private declarations }
  public  { Public declarations }
    function Run( Firm: Integer = INSERT_DATA ): Boolean;
  end;

var FirmEditDG: TFirmEditDG;

implementation

{$R *.dfm}

uses dgTrademarkList;
//======================================================================================================================
{ TFirmEditDG }
//======================================================================================================================
function TFirmEditDG.Run( Firm: Integer ): Boolean;
begin
  if FirmEditDG = nil then Application.CreateForm( TFirmEditDG, FirmEditDG);
  with FirmEditDG do begin
    RequeryParameters( dmLookUp.taTrade, []);
    RequeryParameters( taData, [ Firm ]);
    if (taData.RecordCount = 0) then taData.Insert;
    Result := ( ShowModal = mrOk );
  end;
end;
//======================================================================================================================
procedure TFirmEditDG.sbModelClick(Sender: TObject);
begin
  TrademarkListDG.Run( taDataTrademark.Value, taDataTrademark );
end;
//======================================================================================================================
procedure TFirmEditDG.btQuotesClick(Sender: TObject);
begin
  with edName do
    if SelText <> EmptyStr then SelText := ReplaceQuotation( SelText );
  SetField( taDataClntNameFull, edName.Text);
end;
//======================================================================================================================
procedure TFirmEditDG.taDataBeforePost(DataSet: TDataSet);
begin
//  inherited;
  if taDataClntNameShort.IsNull then taDataClntNameShort.Value := 'temp befor delete';
  if not taDataTrademark.IsNull then taDataClntNameShort.Value := 'temp befor delete';
end;
//======================================================================================================================
end.
