{=======================================================================================================================

   " ".

    , , .

========================================================================================================================

  :

  08.03.2015 [*]       .
  26.02.2015 [*]     .
  24.02.2015 [*]  dmChain.
  22.02.2015 [*] 'D'     .
             [-] TPropStorageEh.
  19.06.2014 [+]    .
  14.06.2014 [*]    .
  13.06.2014 [+] .
  29.12.2012 [+] .
  21.03.2012 [+]  .
  11.03.2012 [*]    .
  28.02.2012 [-]     .
             [+]  .
             [*]    .
  20.02.2012 [*]  .
  16.02.2012 [*] .
  09.02.2012 [!]    Delphi XE2.
  16.07.2009 [+]  .
  17.06.2008 [+]  "".
  12.02.2007 [*]     DBLookupCombobox.
  14.02.2007 [*]   .
  13.02.2007 [*]   .
             [-]  .
  18.12.2006 [+]       .
  15.12.2006 [*]   XP.
  16.11.2001 [-]  .
             [*]    ADO.
             [*]   .
  14.11.2001 [*]   TBASEEditDG.
             [*]  .
  12.11.2001 [*]        .
  08.11.2001 [-]  TAB.
             [*]   MS SQL Server 2000  ODBC   TDataSet.
             [*]   Delphi 6.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgDeviceEdit.pas,v 1.15 2015/03/08 05:02:38 tsk Exp $
=======================================================================================================================}
unit dgDeviceEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Db, StdCtrls, Mask,
      DBCtrls, ExtCtrls, Buttons, ADODB, DBCtrlsEh, DBLookupEh, DBGridEh,
      // Base, Comming & ComputerWare:
      dgBaseEdit, CommingADO, dmLookUpData, dmCommingData;

type
  TDeviceEditDG = class(TBaseEditDG)
    Label1: TLabel;
    lcWorkplace: TDBLookupComboBox;
    edName: TDBEdit;
    edNumb: TDBEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    moDescription: TDBMemo;
    cbReport: TDBCheckBox;
    taDataIdDevice: TAutoIncField;
    taDataDevcIdWorkplace: TIntegerField;
    taDataDevcName: TStringField;
    taDataDevcPrinting: TBooleanField;
    taDataDevcDescription: TMemoField;
    taDataUsed: TSmallintField;
    cbUsed: TDBComboBoxEh;
    edDomain: TDBEdit;
    Label3: TLabel;
    btFind: TBitBtn;
    lcKind: TDBLookupComboboxEh;
    btKind: TSpeedButton;
    taDataDevcIdKind: TSmallintField;
    taDataDepreciation: TStringField;
    edDepr: TDBEdit;
    Label2: TLabel;
    taDataDevcNumber: TStringField;
    Label7: TLabel;
    taDataPrevention: TDateTimeField;
    taDataPreventionExpress: TBooleanField;
    edPrevention: TDBDateTimeEditEh;
    cbPreventionExpress: TDBCheckBoxEh;
    Bevel1: TBevel;
    Bevel2: TBevel;
    DBCheckBoxEh1: TDBCheckBoxEh;
    taDataPreventionNeed: TBooleanField;
    procedure FormShow(Sender: TObject);
    procedure btFindClick(Sender: TObject);
    procedure btKindClick(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    function Run( Device: Integer = -1; Place: Integer = 0 ): Boolean;
  end;

var DeviceEditDG: TDeviceEditDG;

const sType = 'D';

implementation

{$R *.DFM}

uses dgWorkplaceFind, dgKindList, dmChainData;
//======================================================================================================================
function TDeviceEditDG.Run( Device, Place: Integer ): Boolean;
begin
  if DeviceEditDG = nil then Application.CreateForm( TDeviceEditDG, DeviceEditDG );
  with DeviceEditDG do begin
    RequeryParameters( taData, [ Device ]);
    dmChain.Device := Device;
    dmLookUp.SetKindType( 'D' );
    dmLookUp.SetWorkplace( dmChain.Department );
    if taData.RecordCount = 0 then begin
      dmChain.Workplace := Place;
      dmLookUp.SetWorkplace( dmChain.Department );
      taData.Insert;
      taDataDevcIdWorkplace.Value := Place;
    end;
    Result := ( ShowModal = mrOk );
  end;
end;
//======================================================================================================================
procedure TDeviceEditDG.FormShow(Sender: TObject);
begin
  edName.SetFocus;
end;
//======================================================================================================================
procedure TDeviceEditDG.btFindClick(Sender: TObject);
begin
  if WorkplaceFindDG.Run( taDataDevcIdWorkplace ) then begin
    dmChain.Workplace := taDataDevcIdWorkplace.Value;
    dmLookUp.SetWorkplace( dmChain.Department );
  end;
end;
//======================================================================================================================
procedure TDeviceEditDG.btKindClick(Sender: TObject);
begin
  KindListDG.Run( dmLookUp.taKindID.Value, taDataDevcIdKind, 'D' );
end;
//======================================================================================================================
end.
