{=======================================================================================================================

   " ".

     , .

========================================================================================================================

  :

  12.03.2015 [*] FindAny:    .
  04.03.2015 [+]    " ".
             [+]  ChainDM.
  26.02.2015 [+]  (   ).
  22.02.2015 [*]      .
             [*]       .
  21.02.2015 [+]   ,    20.
  20.02.2015 [+] ;
             [-] .
  15.02.2015 [*]  .
  14.02.2015 [*]       ( 8).
  08.06.2013 [*] .
  07.06.2013 [+]   ( ).
  05.06.2013 [+]  .
             [+]  .
  04.06.2013 [*]       MainFM.ViewReport.
  21.03.2012 [*] FindNode:    ,  .
  20.03.2012 [-]  .
             [*]     .
  29.02.2012 [*]  ,   .
  26.02.2012 [*]     .
  25.02.2012 [-]   .
  24.02.2012 [*] .
  19.02.2012 [*]      .
  12.02.2012 [*]      .
  10.02.2012 [*] .
             [!]  .
  09.02.2012 [!]    Delphi XE2.
  30.03.2011 [*]   96 PixelsPerInch.
  18.06.2008 [*]     .
  25.07.2007 [-]  TAB.
  14.02.2007 [+]     .
             [*]   .
             [*]     .
  13.02.2007 [+]   .
  25.12.2006 [*]    taSetNumber  20  50.
  14.12.2006 [*]     .
  09.11.2006 [*]   XP.
  02.10.2002 [*] Action   ().
  11.06.2002 [+]       /.
  21.11.2001 [+]  .
  20.11.2001 [-]  .
  19.11.2001 [+]   .
  16.11.2001 [+]     .
             [+]  ActionList.
             [-]  .
             [*]     .
  15.11.2001 [-]  .
             [+]  .
  14.11.2001 [*] ToolBar   .
  13.11.2001 [*]  :   ADODataSet.
  09.11.2001 [-]  .
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmLayout.pas,v 1.11 2015/03/11 23:05:51 tsk Exp $
=======================================================================================================================}
unit fmLayout;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls, ExtCtrls, Db, Grids, ADODB,
      Menus, DBCtrls, ToolWin, DBGridEh, ActnList, StdCtrls, Variants, ImgList, PropFilerEh, PropStorageEh,
      DBGridEhGrouping, GridsEh, ShellAPI, ToolCtrlsEh, DBGridEhToolCtrls, System.Actions, DBAxisGridsEh, DynVarsEh,
      // ComputerWare:
      dmCommingData, dgDeviceEdit, dgElementEdit, dgDepartmentEdit, dgWorkplaceEdit, dgElementMoveList,
      // Comming:
      CommingOther, CommingDialog, CommingString, CommingADO;

type
  TLayoutMainFM = class(TForm)
    dsSet: TDataSource;
    tvPlace: TTreeView;
    spSet: TSplitter;
    grSet: TDBGridEh;
    taSet: TADODataSet;
    taSetHEXCode: TStringField;
    tbSet: TToolBar;
    btMove: TToolButton;
    tbMain: TToolBar;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    btDelete: TToolButton;
    btPrint: TToolButton;
    ToolButton14: TToolButton;
    ToolButton13: TToolButton;
    alDo: TActionList;
    acAddDprt: TAction;
    acAddPlace: TAction;
    acAddDevice: TAction;
    acDelete: TAction;
    spDelDepartm: TADOStoredProc;
    ToolButton17: TToolButton;
    spDelDevice: TADOStoredProc;
    spDelWorkPlace: TADOStoredProc;
    spLoadTree: TADOStoredProc;
    spLoadTreeCaption: TStringField;
    spLoadTreeID: TIntegerField;
    spLoadTreeHigher: TIntegerField;
    spLoadTreeKind: TStringField;
    spLoadTreeImageType: TIntegerField;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    acUp: TAction;
    acDown: TAction;
    spDelCompSet: TADOStoredProc;
    ToolButton16: TToolButton;
    acSetEdit: TAction;
    acSetH: TAction;
    acSetM: TAction;
    acSetS: TAction;
    btSetH: TToolButton;
    btSetM: TToolButton;
    btSetS: TToolButton;
    taSetID: TIntegerField;
    taSetKind: TStringField;
    taSetModel: TStringField;
    taSetNumber: TStringField;
    acSetMove: TAction;
    ToolButton1: TToolButton;
    ToolButton12: TToolButton;
    stMain: TPropStorageEh;
    acSetInset: TAction;
    ToolButton18: TToolButton;
    taSetType: TStringField;
    imKind: TImageList;
    acSetDelete: TAction;
    ToolButton19: TToolButton;
    acGoDocument: TAction;
    ToolButton20: TToolButton;
    ToolButton21: TToolButton;
    ToolButton22: TToolButton;
    taSetDocument: TIntegerField;
    pnSet: TPanel;
    pnStructure: TPanel;
    grFavorite: TDBGridEh;
    dsFavorite: TDataSource;
    taFavorite: TADODataSet;
    Splitter1: TSplitter;
    acAddToFavorite: TAction;
    ToolButton2: TToolButton;
    tbFavorite: TToolButton;
    acCall: TAction;
    spFavoriteDo: TADOStoredProc;
    taFavoriteID: TIntegerField;
    taFavoriteKeyObject: TStringField;
    taFavoriteName: TStringField;
    pmFavorite: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    caFavoriteDelete: TAction;
    N4: TMenuItem;
    acPrint: TAction;
    spMove: TADOStoredProc;
    acSetClone: TAction;
    spSetClone: TADOStoredProc;
    ToolButton23: TToolButton;
    ToolButton24: TToolButton;
    acDevClone: TAction;
    ToolButton25: TToolButton;
    spDeviceClone: TADOStoredProc;
    acGoModel: TAction;
    ToolButton3: TToolButton;
    taSetDocumentPosition: TSmallintField;
    ToolButton4: TToolButton;
    btReport: TToolButton;
    pmReport: TPopupMenu;
    miLastMove: TMenuItem;
    btPrevention: TMenuItem;
    N5: TMenuItem;
    pmChain: TPopupMenu;
    acChainClient: TAction;
    imChainClient: TMenuItem;
    acGoNet: TAction;
    ToolButton26: TToolButton;
    ToolButton27: TToolButton;
    acGoUser: TAction;
    ToolButton28: TToolButton;
    ToolButton15: TToolButton;
    ToolButton29: TToolButton;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    taSetIDKind: TSmallintField;
    taSetIDModel: TIntegerField;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btEditClick(Sender: TObject);
    procedure taSetHEXCodeGetText(Sender: TField; var Text: String; DisplayText: Boolean);
    procedure ToolButton13Click(Sender: TObject);
//    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure acAddDprtExecute(Sender: TObject);
    procedure acAddDprtUpdate(Sender: TObject);
    procedure acAddPlaceUpdate(Sender: TObject);
    procedure acAddPlaceExecute(Sender: TObject);
    procedure acAddDeviceUpdate(Sender: TObject);
    procedure acAddDeviceExecute(Sender: TObject);
    procedure acDeleteUpdate(Sender: TObject);
    procedure acDeleteExecute(Sender: TObject);
    procedure acUpExecute(Sender: TObject);
    procedure acDownExecute(Sender: TObject);
    procedure acSetEditUpdate(Sender: TObject);
    procedure acSetEditExecute(Sender: TObject);
    procedure grSetDblClick(Sender: TObject);
    procedure acSetHExecute(Sender: TObject);
    procedure acSetMExecute(Sender: TObject);
    procedure acSetSExecute(Sender: TObject);
    procedure tvPlaceChange(Sender: TObject; Node: TTreeNode);
    procedure acSetInsetExecute(Sender: TObject);
    procedure acSetInsetUpdate(Sender: TObject);
    procedure acSetDeleteExecute(Sender: TObject);
    procedure acSetMoveExecute(Sender: TObject);
    procedure acGoDocumentUpdate(Sender: TObject);
    procedure acGoDocumentExecute(Sender: TObject);
    procedure acAddToFavoriteUpdate(Sender: TObject);
    procedure acCallUpdate(Sender: TObject);
    procedure acAddToFavoriteExecute(Sender: TObject);
    procedure acCallExecute(Sender: TObject);
    procedure caFavoriteDeleteExecute(Sender: TObject);
    procedure RefreshFavorite( Key: Variant );
    procedure acPrintUpdate(Sender: TObject);
    procedure acPrintExecute(Sender: TObject);
    procedure btExitClick(Sender: TObject);
    procedure acSetCloneExecute(Sender: TObject);
    procedure acDevCloneExecute(Sender: TObject);
    procedure acDevCloneUpdate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure acGoModelExecute(Sender: TObject);
    procedure acGoModelUpdate(Sender: TObject);
    procedure miLastMoveClick(Sender: TObject);
    procedure btPreventionClick(Sender: TObject);
    procedure acChainClientExecute(Sender: TObject);
    procedure acGoNetUpdate(Sender: TObject);
    procedure acGoUserUpdate(Sender: TObject);
    procedure acChainModelExecute(Sender: TObject);
    procedure acChainKindExecute(Sender: TObject);
    procedure acGoNetExecute(Sender: TObject);
    procedure acGoUserExecute(Sender: TObject);
  private   { Private declarations }
    FSetType: String;
    procedure LoadTree;
    procedure RefreshSet;
    procedure MoveNode ( Kind: String; ID: Integer; Dir: Integer);
    function  SelKind: String;
    function  SelID: Integer;
    function  SelHigher: Integer;
    procedure SetSetType( const Value: String );
    property  SetType: String read FSetType write SetSetType;
  public    { Public declarations }
    procedure   AfterCompleteSetEditPost( State: TDataSetState );
    procedure   FindNode( Kind: String; ID: Integer );
    procedure   FindAny( Kind: String; ID: Integer );
  end;

type
  PReference = ^TReference;
  TReference = record
    Kind: String;     //  .
    Id: Integer;      //  .
    Higher: Integer;  //  .
  end;

var LayoutMainFM: TLayoutMainFM;

implementation

uses fmMain, fmDocumentList, fmModelList, dgFirmList, dgModelList, dgKindList, dmChainData, fmNetComputer, fmNetUser;

{$R *.DFM}
//======================================================================================================================
{ TLayoutMainFM }
//======================================================================================================================
procedure TLayoutMainFM.FormCreate(Sender: TObject);
begin
  FSetType := 'H';
  taFavorite.Open;
end;
//======================================================================================================================
procedure TLayoutMainFM.FormShow(Sender: TObject);
begin
  Width := Width + 1;
end;
//======================================================================================================================
procedure TLayoutMainFM.FormResize(Sender: TObject);
begin
  spSet.Top := pnSet.Top - 4;
end;
//======================================================================================================================
function TLayoutMainFM.SelHigher: Integer;
begin
  Result := PReference( tvPlace.Selected.Data )^.Higher
end;
//======================================================================================================================
function TLayoutMainFM.SelID: Integer;
begin
  Result := PReference( tvPlace.Selected.Data )^.Id
end;
//======================================================================================================================
function TLayoutMainFM.SelKind: String;
begin
  if (tvPlace.Items.Count = 0) then begin
    LoadTree;
    Resize;
    if taFavorite.RecordCount > 0
      then FindNode( DecodeKeyObject( taFavoriteKeyObject.AsString ), DecodeKeyID( taFavoriteKeyObject.AsString ))
      else tvPlace.Select( tvPlace.Items[0] );
//    Result := 'D';
  end else
    Result := PReference( tvPlace.Selected.Data )^.Kind;
end;
//======================================================================================================================
procedure TLayoutMainFM.SetSetType(const Value: String);
  var Device: Integer;
begin
  FSetType := Value;
  case FSetType[1] of
    'H': btSetH.Down := True;
    'M': btSetM.Down := True;
    'S': btSetS.Down := True;
  end;
  Device := PReference(tvPlace.Selected.Data)^.Id;
  RequeryParameters( taSet, [ Device, Value ]);
end;
//======================================================================================================================
procedure TLayoutMainFM.LoadTree;
  var Kind: String;
      ID: Integer;
      nX, nHigher: TTreeNode;
      i: Integer;
      rData: PReference;
      shType: Char;
begin
  Screen.Cursor := crHourGlass;
  if tvPlace.Selected <> nil then begin
    Kind  := SelKind;
    ID    := SelID;
  end
  else ID := -1;
  tvPlace.Items.BeginUpdate;
  tvPlace.Items.Clear;

  with spLoadTree do begin
    Close;
    Open;
    while not Eof do begin
      try
        New( rData );
        rData.Kind   := spLoadTreeKind.AsString[1];
        rData.Id     := spLoadTreeID.Value;
        rData.Higher := spLoadTreeHigher.Value;
        nHigher := nil;
        if spLoadTreeHigher.Value <> 0 then begin
          if spLoadTreeKind.Value = 'V'
            then shType := 'W'
            else shType := 'D';
          for i := 0 to tvPlace.Items.Count - 1 do begin
            if ( PReference( tvPlace.Items[i].Data )^.Id = spLoadTreeHigher.Value ) and
               ( PReference( tvPlace.Items[i].Data )^.Kind = shType )
            then nHigher := tvPlace.Items[i];
          end;
        end;
        nX := tvPlace.Items.AddChild( nHigher, spLoadTreeCaption.AsString );
        nX.ImageIndex    := Pos( spLoadTreeKind.AsString[1], 'DWV') - 1;
        nX.SelectedIndex := nX.ImageIndex;
        nX.Data          := rData;
      except end;
      Next;
    end;
    Close;
  end;

  tvPlace.Items.EndUpdate;
  if ID > 0 then FindNode( Kind, ID );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TLayoutMainFM.tvPlaceChange(Sender: TObject; Node: TTreeNode);
begin
  if taFavorite.RecordCount < 20 then acAddToFavoriteExecute( Sender );
  if PReference(Node.Data)^.Kind = 'V' then begin
      btSetH.Down := True;
      SetType := 'H'
    end else taSet.Close;
end;
//======================================================================================================================
procedure TLayoutMainFM.MoveNode(Kind: String; ID: Integer; Dir: Integer);
begin
  spMove.Parameters[1].Value := Kind;
  spMove.Parameters[2].Value := ID;
  spMove.Parameters[3].Value := Dir;
  spMove.ExecProc;
  LoadTree;
  FindNode( Kind, ID );
end;
//======================================================================================================================
procedure TLayoutMainFM.grSetDblClick(Sender: TObject);
begin
  if acSetEdit.Enabled then acSetEdit.Execute;
end;
//======================================================================================================================
procedure TLayoutMainFM.btEditClick(Sender: TObject);
begin
  case SelKind[1] of
    'D': if DepartmentEditDG.Run( SelID ) then LoadTree;
    'W': if WorkplaceEditDG.Run( SelID )  then LoadTree;
    'V': if DeviceEditDG.Run( SelID )     then LoadTree;
  end;
end;
//======================================================================================================================
procedure TLayoutMainFM.btExitClick(Sender: TObject);
begin
  Application.Terminate;
end;
//======================================================================================================================
procedure TLayoutMainFM.taSetHEXCodeGetText(Sender: TField; var Text: String; DisplayText: Boolean);
begin
  Text := IntToHex(taSetID.AsInteger, 4)
end;
//======================================================================================================================
procedure TLayoutMainFM.RefreshSet;
  var ID: Integer;
begin
  ID := taSetID.Value;
  with taSet do begin
    Close;
    Open;
    Locate('ID', ID, [] );
  end;
end;
//======================================================================================================================
procedure TLayoutMainFM.ToolButton13Click(Sender: TObject);
begin
  LoadTree;
end;
//======================================================================================================================
procedure TLayoutMainFM.FindAny( Kind: String; ID: Integer );
begin
  if Pos ( Kind, 'HMS' ) > 0 then begin
    dmChain.Component := ID;
    FindNode( 'V', dmChain.Device );
    SetType := dmChain.KindType;
    taSet.Locate( 'ID', ID, []);
  end else begin
    FindNode( Kind, ID );
  end;
end;
//======================================================================================================================
procedure TLayoutMainFM.FindNode( Kind: String; ID: Integer );
  var i: Integer;
begin
  for i := 0 to tvPlace.Items.Count - 1 do begin
    if ( PReference( tvPlace.Items[i].Data )^.Kind = Kind ) and
       ( PReference( tvPlace.Items[i].Data )^.Id = ID )
      then tvPlace.Select( tvPlace.Items[i] );
  end;
  if tvPlace.Selected = nil then tvPlace.Select( tvPlace.Items[0] );
end;
//======================================================================================================================
{    }
//======================================================================================================================
procedure TLayoutMainFM.acAddDprtUpdate( Sender: TObject );
begin
  TAction( Sender ).Enabled := ( SelKind = 'D' );
end;
//======================================================================================================================
procedure TLayoutMainFM.acAddDprtExecute(Sender: TObject);
begin
  if DepartmentEditDG.Run( -1, SelID ) then begin
    LoadTree;
    FindNode( 'D', DepartmentEditDG.taDataIdDepartment.Value );
  end;
end;
//======================================================================================================================
procedure TLayoutMainFM.acAddPlaceUpdate(Sender: TObject);
begin
  TAction( Sender ).Enabled := CharInSet( SelKind[1], [ 'D', 'W' ]);
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TLayoutMainFM.RefreshFavorite( Key: Variant );
begin
  if Key = CURRENT_RECORD then Key := taFavoriteID.Value;
  RequeryParameters( taFavorite, [] );
  taFavorite.Locate( 'ID', ( Key), [] );
end;
//======================================================================================================================
procedure TLayoutMainFM.acAddToFavoriteUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( tvPlace.Selected <> nil );
end;
//======================================================================================================================
procedure TLayoutMainFM.acAddToFavoriteExecute(Sender: TObject);
begin
  spFavoriteDo.Parameters[1].Value := 1;
  spFavoriteDo.Parameters[2].Value := EncodeKey( PReference( tvPlace.Selected.Data )^.Kind,
                                                 PReference( tvPlace.Selected.Data )^.Id );
  spFavoriteDo.Parameters[3].Value := tvPlace.Selected.Text;
  spFavoriteDo.ExecProc;
  RefreshFavorite( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TLayoutMainFM.acCallUpdate(Sender: TObject);
begin
  ( Sender as TAction ).Enabled := taFavorite.Active and (taFavorite.RecordCount > 0);
end;
//======================================================================================================================
procedure TLayoutMainFM.acCallExecute(Sender: TObject);
begin
  if taFavorite.RecordCount > 0 then begin
    FindNode( DecodeKeyObject( taFavoriteKeyObject.AsString ), DecodeKeyID( taFavoriteKeyObject.AsString ));
    spFavoriteDo.Parameters[1].Value := 2;
    spFavoriteDo.Parameters[2].Value := taFavoriteKeyObject.Value;
    spFavoriteDo.ExecProc;
  end else tvPlace.Items[0].Selected := True;
  RefreshFavorite( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TLayoutMainFM.caFavoriteDeleteExecute(Sender: TObject);
begin
  spFavoriteDo.Parameters[1].Value := 3;
  spFavoriteDo.Parameters[2].Value := taFavoriteKeyObject.Value;
  spFavoriteDo.ExecProc;
  taFavorite.Prior;
  RefreshFavorite( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TLayoutMainFM.acAddPlaceExecute(Sender: TObject);
begin
  if WorkplaceEditDG.Run( -1, iif( SelKind = 'D', SelID, SelHigher )) then begin
    LoadTree;
    FindNode( 'W', WorkplaceEditDG.taDataIdWorkplace.Value );
  end;
end;
//======================================================================================================================
//  :
procedure TLayoutMainFM.acDevCloneUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( SelKind[1] = 'V' );
end;
//======================================================================================================================
procedure TLayoutMainFM.acDevCloneExecute(Sender: TObject);
  var ID: Integer;
begin
  Screen.Cursor := crHourGlass;
  ID := SelID;
  spDeviceClone.Parameters[1].Value := SelID;
  spDeviceClone.ExecProc;
  LoadTree;
  FindNode( 'D', ID );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TLayoutMainFM.acAddDeviceUpdate(Sender: TObject);
begin
  ( Sender as TAction ).Enabled := CharInSet( SelKind[1], [ 'W', 'V' ]);
end;
//======================================================================================================================
procedure TLayoutMainFM.acAddDeviceExecute(Sender: TObject);
begin
  if DeviceEditDG.Run( INSERT_DATA, iif( SelKind = 'W', SelID, SelHigher )) then LoadTree;
end;
//======================================================================================================================
procedure TLayoutMainFM.acDeleteUpdate(Sender: TObject);
begin
  ( Sender as TAction ).Enabled := ( not tvPlace.Selected.HasChildren );
end;
//======================================================================================================================
procedure TLayoutMainFM.acDeleteExecute(Sender: TObject);
  var H: TTreeNode;
      sName: String;
      CL: Variant;
      IsDeleted: Boolean;
begin
  case SelKind[1] of
    'D': sName := '';
    'W': sName := ' ';
    'V': sName := '';
  end;
  if ShowWarning( '    ' + sName + #13'"%s"?',
                      [ tvPlace.Selected.Text ]) then begin
    if tvPlace.Selected.Parent = nil
      then H := tvPlace.Selected.GetPrev
      else H := tvPlace.Selected.Parent;
    IsDeleted := False;

    case SelKind[1] of
      'D': with spDelDepartm do begin
             Parameters.ParamByName('@Departm').Value := SelID;
             Prepared;
             ExecProc;
             IsDeleted := True;
           end;
      'W': with spDelWorkPlace do begin
             Parameters.ParamByName('@WorkPlac').Value := SelID;
             Prepared;
             ExecProc;
             IsDeleted := True;
           end;
      'V': begin
             CL := SQLCalculate( dmComming.cnGeneral, 'SELECT Kind.KindType FROM CompleteSet ' +
                                'INNER JOIN Model ON CompleteSet.CmplIdModel = Model.IdModel ' +
                                'INNER JOIN Kind ON Model.ModlKind = Kind.IdKind ' +
                                'WHERE (CompleteSet.CmplIdDevice = ' + IntToStr( SelID ) + ')' );
             if CL <> null
             then begin
               if CL = 'H' then sName := '';
               if CL = 'S' then sName := '';
               if CL = 'M' then sName := '';
               ShowStop( '   ' + sName + #13' "%s"',
                                                                         [ tvPlace.Selected.Text ])
             end
             else begin
               with spDelDevice do begin
                 Parameters.ParamByName('@Device').Value := SelID;
                 Prepared;
                 ExecProc;
                 IsDeleted := True;
               end;
             end;
           end;
    end;

    if IsDeleted then begin
      tvPlace.Selected.Delete;
      if H = nil then H := tvPlace.Items[0];
      tvPlace.Selected := H;
    end;
  end;
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TLayoutMainFM.acPrintUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := CharInSet( SelKind[1], [ 'V', 'W' ]);
end;
//======================================================================================================================
procedure TLayoutMainFM.acPrintExecute(Sender: TObject);
begin
  case SelKind[1] of
    'W': MainFM.ViewReport( 'workplace&rs:Command=Render&WP=' + IntToStr( SelID()));
    'V': MainFM.ViewReport( 'device&rs:Command=Render&DV=' + IntToStr( SelID()));
  end;
end;
//======================================================================================================================
//  .
procedure TLayoutMainFM.acUpExecute(Sender: TObject);
begin
  MoveNode( SelKind, SelID, -1 );
end;
//======================================================================================================================
procedure TLayoutMainFM.acDownExecute(Sender: TObject);
begin
  MoveNode( SelKind, SelID, 1 );
end;
//======================================================================================================================
procedure TLayoutMainFM.AfterCompleteSetEditPost(State: TDataSetState);
begin
  taSet.Refresh;
end;
//======================================================================================================================
{  }
//======================================================================================================================
// :
procedure TLayoutMainFM.acSetHExecute(Sender: TObject);
begin
  btSetH.Down := True;
  SetType := 'H';
end;
//======================================================================================================================
procedure TLayoutMainFM.acSetMExecute(Sender: TObject);
begin
  btSetM.Down := True;
  SetType := 'M';
end;
//======================================================================================================================
procedure TLayoutMainFM.acSetSExecute(Sender: TObject);
begin
  btSetS.Down := True;
  SetType := 'S';
end;
//======================================================================================================================
// :
procedure TLayoutMainFM.acSetInsetUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (SelKind[1] = 'V')
end;
//======================================================================================================================
procedure TLayoutMainFM.acSetInsetExecute(Sender: TObject);
begin
  if CompleteSetEditDG.Run( -1, PReference(tvPlace.Selected.Data)^.Id, SetType ) then RefreshSet;
end;
//======================================================================================================================
// :
procedure TLayoutMainFM.acSetCloneExecute(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  spSetClone.Parameters[1].Value := taSetID.Value;
  spSetClone.ExecProc;
  RefreshSet;
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
// :
procedure TLayoutMainFM.acSetEditUpdate( Sender: TObject );
begin
  TAction(Sender).Enabled := ( taSet.Active ) and ( taSet.RecordCount > 0 );
end;
//======================================================================================================================
procedure TLayoutMainFM.acSetEditExecute(Sender: TObject);
begin
  if CompleteSetEditDG.Run( taSetID.Value, -1, taSetType.AsString ) then RefreshSet;
end;
//======================================================================================================================
// :
procedure TLayoutMainFM.acSetDeleteExecute(Sender: TObject);
begin
  if ShowWarning( '    ' + #13'"%s"?', [ taSetModel.Value ] ) then begin
    with spDelCompSet do begin
      Parameters.ParamByName('@CompSet').Value := taSetID.Value;
      ExecProc;
    end;
    taSet.Requery;
  end;
end;
//======================================================================================================================
// :
procedure TLayoutMainFM.acSetMoveExecute(Sender: TObject);
begin
  if ElementMoveListDG.Run( taSetID.Value ) then RefreshSet;
end;
//======================================================================================================================
{     }
//======================================================================================================================
// :
procedure TLayoutMainFM.acGoDocumentUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taSet.Active ) and ( taSet.RecordCount > 0 ) and ( not taSetDocument.IsNull )
end;
//======================================================================================================================
procedure TLayoutMainFM.acGoDocumentExecute(Sender: TObject);
begin
  MainFM.pcMain.ActivePage := MainFM.tsDocument;
  DocumentListFM.RefreshDoc( taSetDocument.Value, taSetDocumentPosition.Value );
end;
//======================================================================================================================
// .
procedure TLayoutMainFM.acGoModelUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taSet.Active ) and ( taSet.RecordCount > 0 )
end;
//======================================================================================================================
procedure TLayoutMainFM.acGoModelExecute(Sender: TObject);
begin
  MainFM.pcMain.ActivePage := MainFM.tsModel;
  ModelListFM.RefreshComponent( taSetID.Value );
end;
//======================================================================================================================
//  ( ).
procedure TLayoutMainFM.acGoNetUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (( SelKind = 'V' ) or (SelKind = 'W'));
end;
//======================================================================================================================
procedure TLayoutMainFM.acGoNetExecute( Sender: TObject );
begin
  MainFM.pcMain.ActivePage := MainFM.tsNet;
  if ( SelKind = 'V' ) then NetComputerFM.RefreshNet( PReference(tvPlace.Selected.Data)^.Id );
  if ( SelKind = 'W' ) then NetComputerFM.RefreshWorkPlace( PReference(tvPlace.Selected.Data)^.Id );
end;
//======================================================================================================================
// .
procedure TLayoutMainFM.acGoUserUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (SelKind = 'W')
end;
//======================================================================================================================
procedure TLayoutMainFM.acGoUserExecute(Sender: TObject);
begin
  MainFM.pcMain.ActivePage := MainFM.tsUser;
  NetUserFM.RefreshWorkplace( PReference(tvPlace.Selected.Data)^.Id );
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TLayoutMainFM.miLastMoveClick(Sender: TObject);
begin
  MainFM.ViewReport( 'last.move' );
end;
//======================================================================================================================
procedure TLayoutMainFM.btPreventionClick(Sender: TObject);
begin
  // .
  MainFM.ViewReport( 'prevention' );
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TLayoutMainFM.acChainKindExecute(Sender: TObject);
  var kd: Integer;
begin
  if (grSet.Focused and taSet.Active and ( taSet.RecordCount > 0 ))
    then kd := taSetIDKind.Value
    else kd := SAVE_RECORD;
  KindListDG.Run( kd );
end;
//======================================================================================================================
procedure TLayoutMainFM.acChainModelExecute(Sender: TObject);
  var model: Integer;
begin
  if ( taSet.Active and ( taSet.RecordCount > 0 ))
    then model := taSetIDModel.Value
    else model := SAVE_RECORD;
  ModelListDG.Run( model );
end;
//======================================================================================================================
procedure TLayoutMainFM.acChainClientExecute(Sender: TObject);
begin
  FirmListDG.Run;
end;
//======================================================================================================================
end.











