{=======================================================================================================================

   "".

    , , .

========================================================================================================================

  :

  01.03.2015 [*]     .
  22.02.2015 [-] TPropStorageEh.
  08.06.2013 [*]  :    .
  12.03.2010 [*]   .
             [*]  .
             [*]  .
  19.02.2012 [*]   .
  09.02.2012 [!]    Delphi XE2.
  03.04.2007 [*]  .
  13.02.2007 [-]    .
  06.02.2007 [*]      XP.
  12.11.2001 [*]   MS SQL Server 2000  ODBC   TDataSet.
             [-]  TAB.
             [*]    .
  08.11.2001 [+]  Comming.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgModelEdit.pas,v 1.8 2015/03/08 05:02:39 tsk Exp $
=======================================================================================================================}
unit dgModelEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DBCtrls, StdCtrls,
      Mask, Buttons, Grids, DBGrids, ExtCtrls, Db, ADODB, Variants, DBCtrlsEh, DBLookupEh, DBGridEh,
      // Comming & ComputerWare:
      CommingOther, CommingADO, dgBaseEdit, dmCommingData, dmLookUpData, dgKindList;

type
  TModelEditDG = class( TBASEEditDG )
    edParameters: TDBEdit;
    Label2: TLabel;
    Label4: TLabel;
    edNumber: TDBEdit;
    Label3: TLabel;
    Label5: TLabel;
    lcProd: TDBLookupComboboxEh;
    DBCheckBox1: TDBCheckBox;
    Label1: TLabel;
    edNote: TDBEdit;
    lcKind: TDBLookupComboboxEh;
    btKind: TSpeedButton;
    btFirm: TSpeedButton;
    taDataIdModel: TAutoIncField;
    taDataModlKind: TSmallintField;
    taDataModlWeight: TIntegerField;
    taDataModlIdProducer: TIntegerField;
    taDataModlNumber: TStringField;
    taDataModlName: TStringField;
    taDataModlNameOnly: TBooleanField;
    taDataModlParametersValue: TStringField;
    taDataModlNote: TStringField;
    taDataComming: TBooleanField;
    spName: TADOStoredProc;
//    procedure sbProdClick(Sender: TObject);
    procedure btKindClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btFirmClick(Sender: TObject);
  private
      { Private declarations }
  public    { Public declarations }
    function Run( ID: Integer; KindID: Integer ): Boolean;
  end;

var ModelEditDG: TModelEditDG;

implementation

{$R *.DFM}

uses dgFirmList, dmChainData;
//======================================================================================================================
{ TModelEditDG }
//======================================================================================================================
function TModelEditDG.Run( ID: Integer; KindID: Integer ): Boolean;
begin
  if ModelEditDG = nil then Application.CreateForm( TModelEditDG, ModelEditDG );
  with ModelEditDG do begin
    RequeryParameters( dmLookUp.taClient, []);
    dmChain.Kind := KindID;
    dmLookUp.SetKindType( dmChain.KindType );
    RequeryParameters( taData, [ ID ]);
    if taData.RecordCount = 0 then begin
      taData.Insert;
      taDataModlKind.Value := KindID;
    end;
    Result := ( ShowModal = mrOk );
  end;
end;
//======================================================================================================================
procedure TModelEditDG.FormCreate(Sender: TObject);
begin
  inherited;
  lcKind.ListSource := dmLookUp.dsKind;
  lcProd.ListSource := dmLookUp.dsClient;
end;
//======================================================================================================================
procedure TModelEditDG.btKindClick(Sender: TObject);
begin
  if KindListDG.Run( dmLookUp.taKindID.Value, taDataModlKind, dmLookUp.taKindKindType.AsString ) then begin
//    dmLookUp.SetKindType( );
  end;
end;
//======================================================================================================================
{procedure TModelEditDG.sbProdClick(Sender: TObject);
begin
  if FirmListDG.Run( taDataModlIdProducer.Value, taDataModlIdProducer ) = mrOK then begin
    with dmLookUp.taClient do begin
      Close;
      Open;
    end;
    taData.Locate( 'ModlIdProducer', taDataModlIdProducer.Value, [] );
  end;
end;}
//======================================================================================================================
procedure TModelEditDG.btFirmClick(Sender: TObject);
begin
  if ( FirmListDG.Run( taDataModlIdProducer.Value, taDataModlIdProducer ) = mrOK )
    then RequeryParameters( dmLookUp.taClient, []);
end;
//======================================================================================================================
procedure TModelEditDG.btSaveClick(Sender: TObject);
//  var CL: Variant;
begin
  if taDataModlIdProducer.Value <= 0 then taDataModlNameOnly.Value := True;
  spName.Parameters[1].Value := taDataModlNumber.Value;
  spName.Parameters[2].Value := taDataModlNameOnly.Value;
  spName.Parameters[3].Value := taDataModlIdProducer.Value;
  spName.ExecProc;
  taDataModlName.AsString := spName.Parameters[4].Value;
{  CL := SQLCalculate( dmComming.cnGeneral,
     'SELECT ClntNameShort FROM Client WHERE (IdClient = ' + taDataModlIdProducer.AsString + ')' );
  taDataModlName.AsString := iif( taDataModlNameOnly.Value, taDataModlNumber.AsString,
                       iif( CL <> null, CL, '......' ) + ' ' + taDataModlNumber.AsString );}
  inherited;
end;
//======================================================================================================================
end.
