{=======================================================================================================================

   " ".

      .

========================================================================================================================

  :

  16.11.2015 [*] CheckVersion   .
             [-] .
  24.07.2015 [*]  ""   "".
  22.07.2015 [+]        ,  .
  21.07.2015 [-]  :    .
  17.04.2015 [*]   .
  06.03.2015 [+]   .
  27.02.2015 [+]  .
  24.02.2015 [+]  "".
  15.02.2015 [*]  .
             [+]  " ".
  14.02.2015 [+]  "".
             [+]  "".
             [+]  " ".
             [*]       ( 8).
  13.06.2014 [+] .
  04.06.2013 [+]  .
             [*] ViewReport:        .
  24.06.2012 [*]  :    .
             [*]     iexplore.exe.
  04.04.2012 [+]  ():   -
             [+]  ():   .
  17.03.2012 [+] :   .
  06.03.2012 [*] :   .
             [+] :  .
  03.03.2012 [*]        dmComming.
  02.03.2012 [+]   .
  01.03.2012 [*]    .
  25.02.2012 [+] :   .
  24.02.2012 [*] .
  17.02.2012 [+] :  
             [*]  ""     MS SQL Reporting Services.
  10.02.2012 [*] .
             [-]    XP.
  09.02.2012 [!]    Delphi XE2.
  31.03.2011 [-] .
  18.06.2008 [+] .
  17.06.2008 [+]  :  .
  20.03.2007 [+]   .
  14.11.2006 [+]  ():   .
  09.11.2006 [*]   XP.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmMain.pas,v 1.15 2015/11/16 02:18:12 tsk Exp $
=======================================================================================================================}

unit fmMain;

interface

uses  Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus, Dialogs, Messages, Contnrs, ActnList, ShellAPI,
      Vcl.ShellAnimations, PropFilerEh, PropStorageEh, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.Buttons, Vcl.Mask, Vcl.DBCtrls,
      Data.DB, Data.Win.ADODB,
      // Comming:
      CommingADO, CommingOther, CommingVersionInfo, CommingSystem;

type
  TMainFM = class(TForm)
    stMain: TPropStorageEh;
    pcMain: TPageControl;
    tsLayout: TTabSheet;
    tsModel: TTabSheet;
    tsDocument: TTabSheet;
    tsChage: TTabSheet;
    tsNet: TTabSheet;
    tsUser: TTabSheet;
    tsSearch: TTabSheet;
    tsVersioan: TTabSheet;
    laFile: TLabel;
    laVersion: TLabel;
    taVersionMax: TADODataSet;
    taVersionMaxMaxVersion: TStringField;
    mmChange: TDBMemo;
    taVersionChange: TADODataSet;
    dsVersionChange: TDataSource;
    taVersionProg: TADODataSet;
    taVersionProgProgramm: TBlobField;
    procedure FormShow(Sender: TObject);
    procedure tsModelShow(Sender: TObject);
    procedure tsDocumentShow(Sender: TObject);
    procedure tsNetShow(Sender: TObject);
    procedure tsChageShow(Sender: TObject);
    procedure tsUserShow(Sender: TObject);
    procedure tsSearchShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private   { Private declarations }
    {$IFDEF RELEASE}
    procedure   CheckVersion;
    {$ENDIF}
  public    { Public declarations }
    procedure   ViewReport( Report: String);
  end;

 var MainFM: TMainFM;

implementation

uses  dmCommingData, fmLayout, fmModelList, fmDocumentList, fmChangeList, fmNetComputer, fmNetUser, fmSearch;

{$R *.DFM}
//======================================================================================================================
{ TMainFM }
//======================================================================================================================
procedure TMainFM.FormCreate(Sender: TObject);
begin
  laVersion.Caption := GetVersion( ' ', True );
  {$IFDEF RELEASE}
  CheckVersion;
  {$ENDIF}
end;
//======================================================================================================================
procedure TMainFM.FormShow(Sender: TObject);
begin
  //  : " ".
  if LayoutMainFM = nil then begin
    Application.CreateForm( TLayoutMainFM, LayoutMainFM );
    LayoutMainFM.Parent := tsLayout;
  end;
  LayoutMainFM.Show;
  pcMain.ActivePageIndex := 0;
end;
//======================================================================================================================
procedure TMainFM.tsModelShow(Sender: TObject);
begin
  // :
  if ModelListFM = nil then begin
    Application.CreateForm( TModelListFM, ModelListFM );
    ModelListFM.Parent := tsModel;
  end;
  ModelListFM.Show;
end;
//======================================================================================================================
procedure TMainFM.tsDocumentShow(Sender: TObject);
begin
  // :
  if DocumentListFM = nil then begin
    Application.CreateForm( TDocumentListFM, DocumentListFM );
    DocumentListFM.Parent := tsDocument;
    DocumentListFM.RefreshDoc;
  end;
  DocumentListFM.Show;
end;
//======================================================================================================================
procedure TMainFM.tsChageShow(Sender: TObject);
begin
  //  :
  if ChangeListFM = nil then begin
    Application.CreateForm( TChangeListFM, ChangeListFM );
    ChangeListFM.Parent := tsChage;
  end;
  ChangeListFM.Show;
end;
//======================================================================================================================
procedure TMainFM.tsNetShow(Sender: TObject);
begin
  //  :
  if NetComputerFM = nil then begin
    Application.CreateForm( TNetComputerFM, NetComputerFM );
    NetComputerFM.Parent := tsNet;
    NetComputerFM.RefreshNet;
  end;
  NetComputerFM.Show;
end;
//======================================================================================================================
procedure TMainFM.tsUserShow(Sender: TObject);
begin
  //  :
  if NetUserFM = nil then begin
    Application.CreateForm( TNetUserFM, NetUserFM );
    NetUserFM.Parent := tsUser;
    NetUserFM.RefreshDCUser;
  end;
  NetUserFM.Show;
end;
//======================================================================================================================
procedure TMainFM.tsSearchShow(Sender: TObject);
begin
  // :
  if SearchFM = nil then begin
    Application.CreateForm( TSearchFM, SearchFM );
    SearchFM.Parent := tsSearch;
  end;
  SearchFM.Show;
end;
//======================================================================================================================
{  }
//======================================================================================================================
{$IFDEF RELEASE}
procedure TMainFM.CheckVersion;
  var ver, prog: String;
begin
  prog := ExtractFilePath( Application.ExeName) + 'update.exe';
  if FileExists( prog ) then DeleteFile( prog );
  RequeryParameters( taVersionMax, []);
  ver := taVersionMaxMaxVersion.AsString;
  taVersionMax.Close;
  if ver <> GetVersionFile then begin
    RequeryParameters( taVersionProg, [ 'update' ]);
    taVersionProgProgramm.SaveToFile( prog );
    ShellExecute( GetDesktopWindow(), nil, PChar( prog ), PChar(''), PChar(''), SW_NORMAL );
    Application.Terminate;
  end;
  RequeryParameters( taVersionChange, [ ver ]);
  if (GetVersionInfo() <> GetProduct( rpVersion )) then SetProduct();
end;
{$ENDIF}
//======================================================================================================================
procedure TMainFM.ViewReport( Report: String );
  var URL: String;
begin
  if GetCompName = 'TSK-HOME'
    then URL := 'http://sreport.filit.ru/ReportServer/Pages/ReportViewer.aspx?%2fComputerWare%2f' + Report
    else URL := 'http://sreport/ReportServer/Pages/ReportViewer.aspx?%2fComputerWare%2f' + Report;
  ShellExecute( Application.Handle, nil, PChar('iexplore.exe'), PChar(URL), PChar(''), SW_MAXIMIZE );
end;
//======================================================================================================================
end.

