{=======================================================================================================================

   " ".

        .

========================================================================================================================

  :

  21.07.2015 [+]  ComputerWare.exe  change.txt.
             [+]  update.exe.
  20.07.2015 [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 2015 TSK Developer Laboratory, Moscow.                                              Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: LoadMain.pas,v 1.1 2015/07/22 11:12:40 tsk Exp $
=======================================================================================================================}
unit LoadMain;

interface

uses  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, Vcl.Controls,
      Vcl.Forms, Vcl.Dialogs, Data.DB, Data.Win.ADODB, PropFilerEh, PropStorageEh, Vcl.StdCtrls, Vcl.Buttons,
      Vcl.ExtCtrls,
      // Comming:
      CommingADO, CommingVersionInfo, CommingString;

type
  TLoadFM = class(TForm)
    cnCW: TADOConnection;
    stProp: TRegPropStorageManEh;
    stMain: TPropStorageEh;
    cbUpdate: TComboBox;
    btFile: TBitBtn;
    dgFile: TOpenDialog;
    Label1: TLabel;
    laVersion: TLabel;
    btSaveUpdate: TBitBtn;
    taProg: TADODataSet;
    taProgID: TSmallintField;
    taProgVersion: TStringField;
    taProgProgramm: TBlobField;
    taProgChange: TMemoField;
    Bevel1: TBevel;
    Label2: TLabel;
    cbProgramm: TComboBox;
    cbChange: TComboBox;
    btPorgramm: TBitBtn;
    btChange: TBitBtn;
    btSaveProgramm: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure btFileClick(Sender: TObject);
    procedure btSaveUpdateClick(Sender: TObject);
    procedure btPorgrammClick(Sender: TObject);
    procedure btChangeClick(Sender: TObject);
    procedure btSaveProgrammClick(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
  end;

var LoadFM: TLoadFM;

implementation

{$R *.dfm}
//======================================================================================================================
procedure TLoadFM.FormCreate(Sender: TObject);
begin
  laVersion.Caption := GetVersionFile;
end;
//======================================================================================================================
procedure TLoadFM.btFileClick(Sender: TObject);
begin
  if (cbUpdate.Text = EmptyStr)
    then dgFile.InitialDir := ExtractFilePath( Application.ExeName )
    else dgFile.InitialDir := ExtractFilePath( cbUpdate.Text );
  if dgFile.Execute then cbUpdate.Text := dgFile.FileName;
end;
//======================================================================================================================
procedure TLoadFM.btSaveUpdateClick(Sender: TObject);
begin
  if FileExists( cbUpdate.Text ) then begin
    Screen.Cursor := crHourGlass;
    ComboBoxItemSave( cbUpdate );
    RequeryParameters( taProg, ['update']);
    if taProg.RecordCount = 0 then begin
      taProg.Insert;
      taProgVersion.AsString := 'update';
    end else begin
      taProg.Edit;
    end;
    taProgProgramm.LoadFromFile( cbUpdate.Text );
    taProg.Post;
    Screen.Cursor := crDefault;
  end;
end;
//======================================================================================================================
procedure TLoadFM.btPorgrammClick(Sender: TObject);
begin
  if (cbProgramm.Text = EmptyStr)
    then dgFile.InitialDir := ExtractFilePath( Application.ExeName )
    else dgFile.InitialDir := ExtractFilePath( cbProgramm.Text );
  if dgFile.Execute then cbProgramm.Text := dgFile.FileName;
end;
//======================================================================================================================
procedure TLoadFM.btChangeClick(Sender: TObject);
begin
  if (cbChange.Text = EmptyStr)
    then dgFile.InitialDir := ExtractFilePath( Application.ExeName )
    else dgFile.InitialDir := ExtractFilePath( cbChange.Text );
  if dgFile.Execute then cbChange.Text := dgFile.FileName;
end;
//======================================================================================================================
procedure TLoadFM.btSaveProgrammClick(Sender: TObject);
  var ver: String;
begin
  if FileExists( cbProgramm.Text ) and FileExists( cbChange.Text ) then begin
    Screen.Cursor := crHourGlass;
    ComboBoxItemSave( cbProgramm );
    ComboBoxItemSave( cbChange );
    ver := GetVersionFile( cbProgramm.Text );
    RequeryParameters( taProg, [ ver ]);
    if taProg.RecordCount = 0 then begin
      taProg.Insert;
      taProgVersion.AsString := ver;
    end else begin
      taProg.Edit;
    end;
    taProgProgramm.LoadFromFile( cbProgramm.Text );
    taProgChange.LoadFromFile( cbChange.Text );
    taProg.Post;
    Screen.Cursor := crDefault;
  end;
end;
//======================================================================================================================
end.
