{=======================================================================================================================

   " ".

        .

========================================================================================================================

  :

  24.07.2015 [*]     OnShow.
  22.07.2015 [+]  .
  20.07.2015 [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 2015 TSK Developer Laboratory, Moscow.                                              Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: UpdateMain.pas,v 1.2 2015/07/24 03:11:36 tsk Exp $
=======================================================================================================================}
unit UpdateMain;

interface

uses  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, Vcl.Controls,
      Vcl.Forms, Vcl.Dialogs, Data.DB, Data.Win.ADODB, Vcl.StdCtrls, Vcl.ComCtrls, ShellAPI,
      // Comming:
      CommingADO, CommingVersionInfo, CommingString;

type
  TUpdateFM = class(TForm)
    cnVersion: TADOConnection;
    laVersion: TLabel;
    StaticText1: TStaticText;
    laMessege: TStaticText;
    pbDone: TProgressBar;
    taProg: TADODataSet;
    taProgProgramm: TBlobField;
    taMax: TADODataSet;
    taMaxMaxVersion: TStringField;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private { Private declarations }
  public  { Public declarations }
  end;

var UpdateFM: TUpdateFM;

implementation

{$R *.dfm}
//======================================================================================================================
procedure TUpdateFM.FormCreate(Sender: TObject);
begin
  laVersion.Caption := GetVersionFile;
end;
//======================================================================================================================
procedure TUpdateFM.FormShow(Sender: TObject);
  var fl, ver: String;
begin
  laMessege.Caption   := '  ';
  cnVersion.Connected := True;
  pbDone.Position     := 1;
//
  laMessege.Caption   := '  ';
  fl := ExtractFilePath( Application.ExeName ) + 'ComputerWare.exe';
  DeleteFile( ChangeFileExt( fl, '.bak'));
  while FileExists( fl ) do MoveFile( PWideChar( fl ), PWideChar( ChangeFileExt( fl, '.bak')));
  pbDone.Position     := 2;
//
  laMessege.Caption   := '  ';
  RequeryParameters( taMax, []);
  ver := taMaxMaxVersion.AsString;
  taMax.Close;
  pbDone.Position     := 3;
//
  laMessege.Caption   := '      ';
  RequeryParameters( taProg, [ ver ]);
  taProgProgramm.SaveToFile( fl );
  taProg.Close;
  ShellExecute( GetDesktopWindow(), nil, PChar( fl ), PChar(''), PChar(''), SW_NORMAL );
  pbDone.Position     := 4;
//
  Application.Terminate;
end;
//======================================================================================================================
end.
