/*=====================================================================================================================

   "".

     .

=======================================================================================================================

  :

  10.03.2012 [*] GridChangeDevice:        .
  26.02.2012 [*]  .
  08.07.2011 [*] GridChangeDevice:  DisplayNumber. 
  17.06.2008 [+] GridChangeDevice:  .
             [+] GridChangeModel:   .
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scChangeList.sql,v 1.2 2012/03/12 12:23:15 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure 'GridChangeModel'
EXECUTE CheckDropProcedure 'GridChangeDevice'
--
GO
--=====================================================================================================================
CREATE PROCEDURE GridChangeModel
AS
  SELECT IdModel AS ID, DisplayName AS Name
    FROM Model
    WHERE (ModlKind = 40)
    ORDER BY DisplayName
--
GO
--=====================================================================================================================
CREATE PROCEDURE GridChangeDevice @MD INT
AS
  SELECT DeviceUnit.IdDevice AS ID,
         Department.DprtName + '; ' + Workplace.WrkpName + '; ' + DeviceUnit.DevcName AS Place, 
         CompleteSet.DisplayNumber AS Number, CompleteSet.IdComponent AS Element,
         DeviceUnit.DateLast, DeviceUnit.DateNext
    FROM CompleteSet 
      INNER JOIN DeviceUnit ON CompleteSet.CmplIdDevice = DeviceUnit.IdDevice 
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
    WHERE (CompleteSet.CmplIdModel = @MD) AND (DeviceUnit.Used > 0)
    ORDER BY DeviceUnit.Used, Place, Number
--
GO
--=====================================================================================================================
-- 
--EXECUTE GridChangeModel
EXECUTE GridChangeDevice 1300
