{=======================================================================================================================

   " ".

     , .

========================================================================================================================

  :

  04.05.2015 [+] Skype.
  04.03.2015 [+] RefreshWorkplace:   .
             [-] .
  01.03.2015 [+]    " ".
  16.02.2015 [*]       ( 8).
  15.02.2015 [-]   .
             [+]    fmNet.  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmNetUser.pas,v 1.6 2015/05/04 06:32:24 tsk Exp $
=======================================================================================================================}
unit fmNetUser;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Mask, DBGridEh, ADODB,
      ToolWin, ComCtrls, DB, DBCtrls, Grids, ExtCtrls, Buttons, ActnList, DBGridEhGrouping, GridsEh, DynVarsEh,
      PropFilerEh, PropStorageEh, ToolCtrlsEh, DBGridEhToolCtrls, System.Actions, DBAxisGridsEh,
      // ComputerWare:
      dmCommingData, dgUserDCScan, dgUserEdit, dgUserInstall,
      // Comming:
      CommingADO, CommingDialog, Vcl.Menus;

type
  TNetUserFM = class( TForm )
    dsNode: TDataSource;
    taNode: TADODataSet;
    tbMain: TToolBar;
    alNet: TActionList;
    acRefresh: TAction;
    stMain: TPropStorageEh;
    ToolButton5: TToolButton;
    acGoWorkplace: TAction;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    taNodeID: TIntegerField;
    taNodeWorkplace: TStringField;
    taNodePhone: TStringField;
    taUser: TADODataSet;
    dsUser: TDataSource;
    taUserID: TIntegerField;
    taUserLogin: TStringField;
    taUserName: TStringField;
    taUserPass: TStringField;
    ToolButton1: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton10: TToolButton;
    acUserInsert: TAction;
    acUserEdit: TAction;
    acUserDelete: TAction;
    spUser: TADOStoredProc;
    grUsers: TDBGridEh;
    taDCUser: TADODataSet;
    dsDCUser: TDataSource;
    taDCUserID: TIntegerField;
    taDCUserLogin: TStringField;
    taDCUserDomain: TStringField;
    taDCUserName: TStringField;
    taDCUserWorkplace: TStringField;
    taDCUserPhone: TStringField;
    Label1: TLabel;
    taDCUserPass: TStringField;
    taDCUserAddName: TStringField;
    DBEdit1: TDBEdit;
    taDCUserEMail: TStringField;
    taDCUserMailPass: TStringField;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    acCheckUser: TAction;
    ToolButton4: TToolButton;
    spIgnore: TADOStoredProc;
    ToolButton13: TToolButton;
    acUserInstall: TAction;
    ToolButton12: TToolButton;
    ToolButton14: TToolButton;
    acUserInfo: TAction;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    taNodeDomain: TStringField;
    DBEdit6: TDBEdit;
    Label6: TLabel;
    DBEdit7: TDBEdit;
    taDCUserWorkplaceID: TIntegerField;
    taDCUserEMailGroup: TStringField;
    asReportList: TAction;
    pmReport: TPopupMenu;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    acReportMail: TAction;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    DBEdit8: TDBEdit;
    taDCUserSkypeLogin: TStringField;
    taDCUserSkypePass: TStringField;
//    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure acGoWorkplaceUpdate(Sender: TObject);
    procedure acRefreshExecute(Sender: TObject);
    procedure acUserInsertUpdate(Sender: TObject);
    procedure acUserInsertExecute(Sender: TObject);
    procedure acUserEditUpdate(Sender: TObject);
    procedure acUserEditExecute(Sender: TObject);
    procedure acUserDeleteExecute(Sender: TObject);
    procedure acCheckUserUpdate(Sender: TObject);
    procedure acCheckUserExecute(Sender: TObject);
    procedure acUserInstallExecute(Sender: TObject);
    procedure acUserInfoExecute(Sender: TObject);
    procedure acUserInfoUpdate(Sender: TObject);
    procedure acGoWorkplaceExecute(Sender: TObject);
    procedure asReportListExecute(Sender: TObject);
    procedure acReportMailExecute(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    procedure   RefreshDCUser( ID: Integer = CURRENT_RECORD );
    procedure   RefreshWorkplace( ID: Integer );
  end;

var  NetUserFM: TNetUserFM;

implementation

uses fmMain, dgUserComputerEdit, dgComputerPing, fmLayout;
{$R *.DFM}
//======================================================================================================================
{ TNetUserFM }
//======================================================================================================================
procedure TNetUserFM.RefreshDCUser( ID: Integer );
begin
  Screen.Cursor := crHourGlass;
  if (ID = CURRENT_RECORD) and taDCUser.Active then ID := taDCUserID.Value;
  RequeryParameters( taDCUser, []);
  taDCUser.Locate('ID', ID, [] );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TNetUserFM.RefreshWorkplace(ID: Integer);
begin
  if not taDCUser.Locate('WorkplaceID', ID, [] ) then taDCUser.First;
end;
//======================================================================================================================
procedure TNetUserFM.acRefreshExecute(Sender: TObject);
begin
  RefreshDCUser( CURRENT_RECORD );
end;
//======================================================================================================================
// :
//======================================================================================================================
//  :
procedure TNetUserFM.acCheckUserUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taDCUser.Active);
end;
//======================================================================================================================
procedure TNetUserFM.acCheckUserExecute(Sender: TObject);
begin
  UserDCScanDG.Run;
  RefreshDCUser( CURRENT_RECORD );
end;
//======================================================================================================================
procedure TNetUserFM.acUserInsertUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taDCUser.Active)
end;
//======================================================================================================================
procedure TNetUserFM.acUserInstallExecute(Sender: TObject);
begin
  UserInstallDG.Run( taDCUserID.Value )
end;
//======================================================================================================================
procedure TNetUserFM.acUserInsertExecute(Sender: TObject);
begin
  if UserEditDG.Run( INSERT_DATA ) then RefreshDCUser( UserEditDG.taDataID.Value );
end;
//======================================================================================================================
procedure TNetUserFM.acUserEditUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taDCUser.Active) and ( taDCUser.RecordCount > 0 );
end;
//======================================================================================================================
procedure TNetUserFM.acUserEditExecute(Sender: TObject);
begin
  if UserEditDG.Run( taDCUserID.Value ) then RefreshDCUser( CURRENT_RECORD );
end;
//======================================================================================================================
//   :
procedure TNetUserFM.acUserInfoUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taDCUser.Active) and ( taDCUser.RecordCount > 0 );
end;
//======================================================================================================================
procedure TNetUserFM.acUserInfoExecute(Sender: TObject);
begin
  MainFM.ViewReport( 'user.info&rs:Command=Render&ID=' + taDCUserID.AsString);
end;
//======================================================================================================================
// :
procedure TNetUserFM.acUserDeleteExecute(Sender: TObject);
begin
  if ShowAskDelete( taDCUserDomain.AsString + '/' + taDCUserLogin.AsString + ': ' + taDCUserName.AsString ) then begin
    spIgnore.Parameters[1].Value := taDCUserID.Value;
    spIgnore.ExecProc;
    taDCUser.Prior;
    RefreshDCUser( CURRENT_RECORD );
  end;
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TNetUserFM.asReportListExecute(Sender: TObject);
begin
  MainFM.ViewReport( 'user.list' ); //  .
end;
//======================================================================================================================
procedure TNetUserFM.acReportMailExecute(Sender: TObject);
begin
  MainFM.ViewReport( 'mail.box' );  //  .
end;
//======================================================================================================================
//  .
//======================================================================================================================
procedure TNetUserFM.acGoWorkplaceUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taDCUser.Active) and ( taDCUser.RecordCount > 0 ) and ( not taDCUserWorkplaceID.IsNull );
end;
//======================================================================================================================
procedure TNetUserFM.acGoWorkplaceExecute(Sender: TObject);
begin
  MainFM.pcMain.ActivePage := MainFM.tsLayout;
  LayoutMainFM.FindNode( 'W', taDCUserWorkplaceID.Value );
end;
//======================================================================================================================
end.







